//-----------------------------------------
@version 2.5
@script generic
@name RemoveAutomaton

@define AUTOMATON_VER 2.0


/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xParentItem ;

/* searchItem */
s_xSearchItem = nil ;

generic 
{
	curScene = Scene();
	/* puah seleced item */
	xSelected = curScene.firstSelect();
	if( xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}	
	push_selected_item( curScene , xSelected );
	curItem = s_xParentItem ;
	
    reqbegin("RemoveAutomaton " + AUTOMATON_VER );

    reqsize(200,100);
	c0 = ctltext("----Warning!!---","Remove Automaton");
    ctlposition(c0,40,15,262,19);
    return if !reqpost();
    reqend();

	CommandInput( "AutoConfirm 1" );
	select_by_name( curItem , "Root" );
	if( s_xSearchItem == nil )
	{
		error("<br>You must select Automaton Item" );
		return ;
	}
	xObject = s_xSearchItem.parent ;
	CommandInput( "ClearSelected" );
	SelectItem( xObject.id );
	CommandInput( "ParentItem 0" );
	SelectItem( s_xParentItem.id );
	CommandInput( "ClearSelected" );
	CommandInput( "AutoConfirm 0" );
	
	SelectItem( xObject.id );
}

/* push/pop seleced item  */
push_selected_item:scene , xSelected 
{
	/* get selected item */
	for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
	{
		s_axSelectedItem[ s_nSelectedNum ] = xSelected ;
		xSelected = scene.nextSelect();
	}
	/* seek Top Item  */
	s_xParentItem = s_axSelectedItem[ 1 ] ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}

/* push/pop seleced item  */
pop_selected_item
{
	// select item 
	SelectItem( s_axSelectedItem[ 1 ].id );
	for( nLoop = 2 ; nLoop < s_nSelectedNum ; nLoop++ )
	{
		AddToSelection( s_axSelectedItem[ nLoop ].id );
	}
}

/********************************************/
select_by_name: xRoot , sName 
{
	// use s_xSearchItem 
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}

searchItem: s_xItem , sName 
{
	// use s_xSearchItem 
	xMesh = s_xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = s_xItem.nextChild();
	}
}



