//-----------------------------------------
// ATIKCtrl -- LScript Genetic
// Noboru Fujiyama 2003/07/22
//                 2003/09/25  add Automaton Model
//  Acs3b/Automaton IK/FK On/Off etc 
@version 2.5
@script generic
@name ATIKCtrl

@define AUTOMATON_VER 2.0

s_xFlag = 1 ;

// use get_object_channel_group 
var s_xChannelGrp = nil ;
/* use searchItem & select_by_name */
s_xSearchItem = nil ;

/* puah/pop seleced item */
s_nSelectedNum ;
s_axSelectedItem ;
s_xParentItem ;

var s_xItem ;

options
{

}

button_callback_c3 
{
	xChannel = get_object_channel_group( s_xItem , "IK_1" );
	//CommandInput( "GraphEditor 1" );
	//CommandInput( "GE_SelectAllKeys 1
	CommandInput( "GE_OpenWindow 1 " );
	CommandInput( "GE_GetLayoutSel 0" );
	CommandInput( "GE_FilterSelection \"*.IK*\"");
	CommandInput( "GE_SelectAllCurves" );
	s_nEndFlag = 1 ;
    reqabort();
 
}
button_callback_c4
{
	CommandInput("EditServer DisplacementHandler 1");
    reqabort();
}

generic 
{
	sTempFile = getdir("Content");
	sTempFile += "\\ikOnOff.txt" ;
	xScene = Scene();	
	xSelected = xScene.firstSelect();	
	if(xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}
	push_selected_item( xScene , xSelected );
	xParent = get_top_item( xSelected );
	s_xItem = select_by_name( xParent , "IKSlidHolder" ) ;
	if( nil == s_xItem )
	{
		error("<br>You must select charactor item " );
		return;		
		
	}
    var1 = 1;

    reqbegin("IK/FK Control " + AUTOMATON_VER );
    reqsize(358,102);

    c1 = ctltab("IK      ","Command ");
    ctlposition(c1,2,0);

    c2 = ctlchoice("Type",var1,@"body","lower","upper ","non","delete"@);
	ctlposition(c2,7,27,238,24);

    c3 = ctlbutton("Graph",80,"button_callback_c3");
    ctlposition(c3,16,34);
    
    c4 = ctlbutton("Slider",80,"button_callback_c4");
    ctlposition(c4,100,34);

    ctlpage(1,c2);
    ctlpage(2,c4,c3);
    return if !reqpost();

    var1 = getvalue(c2);

    reqend();


	/*
    reqbegin("IK/FK ON OFF");
    reqsize(309,69);

    c1 = ctlchoice("Type",var1,@"body","lower","upper ","non","delete"@);
    ctlposition(c1,0,0,250,24);

    return if !reqpost();

    var1 = getvalue(c1);

    reqend();
	*/


	xChannel = get_object_channel_group( s_xItem , "IK_1" );
	if( xChannel != nil )
	{
		if( var1 == 1 )
		{
			createChannelKeys( xChannel , "ActivateIK" , xScene.currenttime , 1 );
			createChannelKeys( xChannel , "BothArmsIK" , xScene.currenttime , 1 );
			createChannelKeys( xChannel , "BothLegsIK" , xScene.currenttime , 1 );
		}
		else if( var1 == 3 )
		{
			createChannelKeys( xChannel , "ActivateIK" , xScene.currenttime , 1 );
			createChannelKeys( xChannel , "BothArmsIK" , xScene.currenttime , 1 );
			createChannelKeys( xChannel , "BothLegsIK" , xScene.currenttime , 0 );
		}
		else if( var1 == 2 )
		{
			createChannelKeys( xChannel , "ActivateIK" , xScene.currenttime , 1 );
			createChannelKeys( xChannel , "BothArmsIK" , xScene.currenttime , 0 );
			createChannelKeys( xChannel , "BothLegsIK" , xScene.currenttime , 1 );
		}
		else if( var1 == 4 )
		{
			createChannelKeys( xChannel , "ActivateIK" , xScene.currenttime , 0 );
			createChannelKeys( xChannel , "BothArmsIK" , xScene.currenttime , 0 );
			createChannelKeys( xChannel , "BothLegsIK" , xScene.currenttime , 0 );
		}		else if( var1 == 5 )
		{
			deleteChannelKeys( xChannel , "ActivateIK" , xScene.currenttime );
			deleteChannelKeys( xChannel , "BothArmsIK" , xScene.currenttime );
			deleteChannelKeys( xChannel , "BothLegsIK" , xScene.currenttime );
		}
		
	}
	pop_selected_item() ;

}
/******************************************************/
get_object_channel_group : xSelected , sName 
{
	// use s_xChannelGrp; 
	xChannelGrp = ChannelGroup();
	s_xChannelGrp = nil ;
	object_channel_group( xSelected , xChannelGrp , sName  );
	return s_xChannelGrp ;
}

object_channel_group : xSelected , xChannelGrp , sName 
{	
	// use s_xChannelGrp; 
	while( xChannelGrp != nil )
	{
		if( xChannelGrp.parent.name == xSelected.name )
		{
			if( xChannelGrp.name == sName )
			{
				s_xChannelGrp = xChannelGrp ;
				break ;
			}
		}
		object_channel_group( xSelected , ChannelGroup(  xChannelGrp ) , sName  ) ;
		if( nil != s_xChannelGrp ) 
		{
			break ;
		}
		xChannelGrp = xChannelGrp.next();
	}
	return s_xChannelGrp ;
}

createChannelKeys: xGroup , sChannelName , time , value 
{
	curChannel = xGroup.firstChannel();

	while( nil != curChannel )
	{
		if(curChannel.name == sChannelName )
		{
			createKey( curChannel , time , value );
			break ;
		}
		curChannel = xGroup.nextChannel();
	}
}

createKey: xChanel , time , value  
{
	if( 1 == s_nValueChk )
	{
		temp = xChanel.value( time );
		if( value != temp ) 
		{
			xChanel.createKey( time ,value );
		}
	}
	else {
		xChanel.createKey( time ,value );
	}
}

deleteChannelKeys: xGroup , sChannelName , time  
{
	curChannel = xGroup.firstChannel();

	while( nil != curChannel )
	{
		if(curChannel.name == sChannelName )
		{
			for( nLoop = 1 ; nLoop <=  curChannel.keyCount ; nLoop++ )
			{
				
				if( time == curChannel.getKeyTime( curChannel.keys[ nLoop ] ) )
				{
					curChannel.deleteKey( curChannel.keys[ nLoop ] );
					break ;
				}
			}
			break ;
		}
		curChannel = xGroup.nextChannel();
	}
}

/* get_top_item  */
get_top_item : xSelected 
{
	/* seek Top Item  */
	xParentItem = xSelected ;
	while( nil != xParentItem.parent )
	{
		xParentItem = xParentItem.parent ;
	}
	return xParentItem ;
}

/********************************************/
select_by_name: xRoot , sName 
{
	// use s_xSearchItem 
	s_xSearchItem = nil ;
	xName = parse( " (" , xRoot.name ) ;
	if( sName == xName[ 1 ] )	
	{
		s_xSearchItem = xRoot ;
		return s_xSearchItem ;
	}
	searchItem( xRoot , sName ) ;
	if( nil != s_xSearchItem )
	{
		SelectItem( s_xSearchItem.id );
	}
	else {
		// info( "Item [" , sName , "] Not found!!  " , xRoot );
	}
	return s_xSearchItem ;
}

searchItem: s_xItem , sName 
{
	// use s_xSearchItem 
	xMesh = s_xItem.firstChild();
	while( xMesh )
	{
		xName = parse( " (" , xMesh.name ) ;
		if( sName == xName[ 1 ] )
		{
			s_xSearchItem  = xMesh ;		
			return ;
		}
		else {
			searchItem( xMesh , sName  );
			if( nil != s_xSearchItem )
			{
				return ;		
			}
		}
		xMesh = s_xItem.nextChild();
	}
}

/* push/pop seleced item  */
push_selected_item:scene , xSelected 
{
	/* get selected item */
	for( s_nSelectedNum = 1 ; xSelected ; ++s_nSelectedNum )
	{
		s_axSelectedItem[ s_nSelectedNum ] = xSelected ;
		xSelected = scene.nextSelect();
	}
	/* seek Top Item  */
	s_xParentItem = s_axSelectedItem[ 1 ] ;
	while( nil != s_xParentItem.parent )
	{
		s_xParentItem = s_xParentItem.parent ;
	}
}

/* push/pop seleced item  */
pop_selected_item
{
	// select item 
	SelectItem( s_axSelectedItem[ 1 ].id );
	for( nLoop = 2 ; nLoop < s_nSelectedNum ; nLoop++ )
	{
		AddToSelection( s_axSelectedItem[ nLoop ].id );
	}
}

