//-----------------------------------------
// IKtoRotClient -- LScript Motion
// Noboru Fujiyama 2003/05/27
//  IK->Local Rotation file
//
//  used SaveACSPose.ls Acs3bIKtoFK.ls
//  use temporay file [Content]/temp/localrot/[Item Name].txt
@version 2.5
@script motion
@name IKtoRotClient

vRot = < 0 , 0 , 0 >;
sFilePath ;
sObjName ;

create: obj
{
	sObjName = get_name( obj.name ) ;
	sFilePath =  getdir("Content");
	sFilePath += "/temp/localrot/";
	sFilePath += sObjName ;
	sFilePath += ".txt" ;
	file = File( sFilePath , "w") || error( "Not Create Data File" );
	file.write( sObjName , ":" );
	file.write( " <" , vRot , ">\n" );
}

destroy
{
	file = File( sFilePath , "w");
}

flags
{
     return(AFTERIK);
}


process: ma, frame, time
{
	vTemp = ma.get(ROTATION,time) ;
	if( vRot != vTemp )
	{
		vRot = vTemp ;
		file = File( sFilePath , "w");
		file.write( sObjName , ":" );
		file.write( " <" , vRot , ">\n" );
	}
}

get_name:sName
{
	tokens = parse( " ()" , sName ); 
	return tokens[ 1 ] ;
}

